#include "turtel.h"

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

char *int_to_str(int d) {
  char *ret;
  int i = 0, tmp = d, j;

  do {
    tmp /= 10;
    i ++;
  } while (tmp != 0);

  ret = malloc(sizeof(char) * (++i + 1));

  for (j = 0; j < i; j++)
    ret[j] = '\0';

  sprintf(ret, "%d", d);
  return ret;
}

void trl_getdl(int argc, char **argv) {
  err("getdl");
}

void trl_rundl(int argc, char **argv) {
  err("rundl");
}

void trl_str_fc(int argc, char **argv) {
  char *val;
  if (argc != 1) {
    err("runtime: error using builtin _str_fc: expected 1 argument, got %d", 
        argc);
  }

  if (getvar(argv[0], Str) == NULL) {
    setvar(argv[0], Str, "-1");
    /* yay! it's a NuLL ptr, or an empty empty string
     * (it's -1 because fuck you) */
  } else {
    val = int_to_str((int)getvar(argv[0], Str)[0]);
    setvar(argv[0], Str, val);
    free(val);
  }
}

void trl_str_mv(int argc, char **argv) {
  char *val;
  if (argc != 1) {
    err("runtime: error using builtin _str_mv: expected 1 argument, got %d", 
        argc);
  }

  if (getvar(argv[0], Str) == NULL)
    err("runtime: _str_mv %s is an empty variable. exiting.", argv[0]);

  /*printf("getvar argv[0] addr = %p\n", getvar(argv[0], Str));*/
  /*printf("getvar argv[0] = \"%s\"\n", getvar(argv[0], Str));*/

  val = malloc(sizeof(char) * (strlen(getvar(argv[0], Str)) + 1));
  strcpy(val, getvar(argv[0], Str));
  val[strlen(val)] = '\0';
  /*printf("val addr = %p\n", val);*/

   ++val;
  /*puts("after ↓");*/
  /*printf("val addr: %p\n", val);*/
  /*iprintd((int)strlen(val));*/
  /*iprints(val);*/

  setvar(argv[0], Str, val);

  free(--val);
}

void trl_win_create(int argc, char **argv) {
  if (argc != 2) {
    err("runtime: error using builtin win_create: expected 2 arguments, got %d", 
        argc);
  }

  x_create_win(atoi(getvar(argv[0], Num)), atoi(getvar(argv[1], Num)));
}

void trl_win_delete(int argc, char **argv) {
  if (argc != 0) {
    err("runtime: error using builtin win_delete: expected 0 arguments, got %d", 
        argc);
  }

  x_del_win();
}

void trl_win_draw(int argc, char **argv) {
  if (argc != 5) {
    err("runtime: error using builtin win_delete: expected 5 arguments, got %d", 
        argc);
  }

  x_draw(
    atoi(getvar(argv[0], Num)),
    atoi(getvar(argv[1], Num)),
    atoi(getvar(argv[2], Num)),
    atoi(getvar(argv[3], Num)),
    atoi(getvar(argv[4], Num))
  );
}

void trl_nowequ(int argc, char **argv) {
  Type t1, t2;
  if (argc != 4) {
    err("runtime: error using builtin nowequ: expected 4 arguments, got %d", 
        argc);
  }

  t1 = gettype(argv[0]);
  t2 = gettype(argv[2]);

  setvar(argv[1], t1, getvar(argv[3], t2));
}

void trl_exit(int argc, char **argv) {
  if (argc != 0) {
    err("runtime: error using builtin exit: expected 0 arguments, got %d", 
        argc);
  }

  exit(0);
}

void trl_srun(int argc, char **argv) {
  if (argc != 1) {
    err("runtime: error using builtin exit: expected 1 argument, got %d", 
        argc);
  }

  err("cannot sysstem()");
  /*system(getvar(argv[0], Str));*/
}

#ifdef WITH_ARRAYS
char *get_arr_varname(char *s) {
  int bufsiz = 0,
      done = 0,
      arrindex_n = 0,
      sz = 0,
      tmp,
      bname_sz = 0,
      i;
  char *arrindex,
       *ret = NULL,
       *s_bak = s,
       *bname;
  extern Variable *var;
  extern int base_var_approx;
  while (*s) {
    if (done)
      err("runtime: invalid syntax near '%s'", s);
    else
      bname_sz++;

    if (*s == '[') {
      while (*++s != ']')
        if (!*s)
          err("runtime: cannot access array '%s' - '[' not terminated", s);
        else
          ++bufsiz;
      if (!bufsiz)
        err("runtime: bufsiz for arrindex empty (%s)", s);
      arrindex = malloc(bufsiz + 1);
      strncpy(arrindex, s-bufsiz, bufsiz);
      arrindex[bufsiz] = 0;
      tmp = arrindex_n = atoi(getvar(arrindex, Num));
      do {
        tmp /= 10;
        sz++;
      } while (tmp != 0);

      bname = malloc(bname_sz);
      strncpy(bname, s_bak, bname_sz - 1);
      bname[bname_sz - 1] = 0;

      ret = malloc(sz + strlen(bname) + 22);
      sprintf(ret, "__internal__arr__%s__%d__", bname, arrindex_n);
      ret[sz + strlen(bname) + 21] = 0;

      /* important!! reallocing the extern variable list !!!*/
      var = realloc(var, sizeof(*var) * ++base_var_approx);

      free(arrindex);
      done++;
    }
    ++s;
  }

  /*iprints(ret);*/
  /*fflush(stdout);*/
  if (ret == NULL)
    return s_bak;
  return ret;
}
#endif

void trl_print(int argc, char **argv) {
  Type t;
  char *v;
  if (argc != 2) {
    err("runtime: error using builtin print: expected 2 arguments, got %d", 
        argc);
  }
  t = gettype(argv[0]);
  v = getvar(argv[1], t);

  printf("%s", v);
  /*if (t == Num && isdigit(argv[1][0]))*/
    /*free(v);*/
  /* free printed ptr, only if it was allocated dynamically (is a digit) */
  fflush(stdout);
}

void trl_nvar(int argc, char **argv) {
  Type t = gettype(argv[1]);
  char *name = argv[0];

  if (argc != 3) {
    err("runtime: error creating var: expected 2 arguments, got %d", 
        argc-1);
    /* variable name provided as argv[0] */
  }

#ifdef WITH_ARRAYS
  /* a very ghetto implementation of arrays; not idiot-proof, delete 
   * -DWITH_ARRAYS from Makefile to disable
   */
  name = get_arr_varname(argv[0]);
#endif

  if (t == Num && (isdigit(name[0]) || name[0] == '-'))
    err("runtime: cannot write variables into numerical constants (%s)", 
        name[0]);

  setvar(name, t, argv[2]);
}

void trl_read(int argc, char **argv) {
  char tread[MAX_TRL_READ] = { '\0' };
  if (argc != 2) {
    err("runtime: error using builtin read: expected 2 arguments, got %d", 
        argc);
  }

  if (gettype(argv[0]) == Num && (isdigit(argv[1][0]) || argv[1][0] == '-'))
    err("runtime: read: cannot read into numerical constants");

  fgets(tread, MAX_TRL_READ, stdin);

  setvar(argv[1], gettype(argv[0]), tread);
}

void trl_add(int argc, char **argv) {
  char *tmp;
  if (argc != 2) {
    err("runtime: error using builtin add: expected 2 arguments, got %d", 
        argc);
  }
  tmp = int_to_str(
    atoi(getvar(argv[0], Num)) + atoi(getvar(argv[1], Num)));
  setvar(argv[0], Num, tmp);
  free(tmp);
}

void trl_sub(int argc, char **argv) {
  char *tmp;
  if (argc != 2) {
    err("runtime: error using builtin sub: expected 2 arguments, got %d", 
        argc);
  }
  tmp = int_to_str(
    atoi(getvar(argv[0], Num)) - atoi(getvar(argv[1], Num)));
  setvar(argv[0], Num, tmp);
  free(tmp);
}

void trl_mul(int argc, char **argv) {
  char *tmp;
  if (argc != 2) {
    err("runtime: error using builtin mul: expected 2 arguments, got %d", 
        argc);
  }
  tmp = int_to_str(
    atoi(getvar(argv[0], Num)) * atoi(getvar(argv[1], Num)));
  setvar(argv[0], Num, tmp);
  free(tmp);
}

void trl_div(int argc, char **argv) {
  char *tmp;
  if (argc != 2) {
    err("runtime: error using builtin div: expected 2 arguments, got %d", 
        argc);
  }
  tmp = int_to_str(
    atoi(getvar(argv[0], Num)) / atoi(getvar(argv[1], Num)));
  setvar(argv[0], Num, tmp);
  free(tmp);
}

void trl_mod(int argc, char **argv) {
  char *tmp;
  if (argc != 2) {
    err("runtime: error using builtin sub: expected 2 arguments, got %d", 
        argc);
  }
  tmp = int_to_str(
    atoi(getvar(argv[0], Num)) % atoi(getvar(argv[1], Num)));
  setvar(argv[0], Num, tmp);
  free(tmp);
}
