#include "turtel.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void free_prog(Program p) {
  int i, j;
  for (i = 0; i < p.steps; i++) {
    for (j = 0; j < p.expr[i].argc; j++)
      free(p.expr[i].argv[j]);
    if (p.expr[i].argc > 0)
      free(p.expr[i].argv);
  }

  free(p.expr);
}

int main (int argc, char *argv[]) {
  int opt,
      debug = 0;

  FILE *in;
  int c;
  Program prg;

  if (argv[1] != NULL) {
    in = fopen(argv[1], "r");
    if (in == NULL) {
      fprintf(stderr, "failed to open %s\n", argv[1]);
      exit(1);
    }
  } else {
#ifdef LINUX
    in = tmpfile();
    while ((c = fgetc(stdin)) != EOF)
      fputc(c, in);

    rewind(in);
#else
#endif

  }

  prg = trl_lex(in);

  if (debug)
    dbg_print_prog_tree(prg);

  run(prg);
  free_prog(prg);

  fclose(in);
  return 0;
}
